#include "search_star.h"

QueryVariable *QueryVariable::head = NULL;

QueryVariable::QueryVariable (const char *varName, const char *varValue)
{
	name = new char [strlen(varName) + 1];
	strcpy (name, varName);
	value = new char [strlen(varValue) + 1];
	strcpy (value, varValue);
	next = NULL;
}

QueryVariable::~QueryVariable()
{
	delete [] name;
	delete [] value;
	if (next)
		delete	next;
}

void QueryVariable::Append (QueryVariable *newLast)
{
	if (!head)
		head = newLast;
	else
	{
		QueryVariable	*p = head;
		while (p->next)
			p = p->next;
		p->next = newLast;
	}
}

void QueryVariable::MakeAndAppend (const char *varName, const char *varValue)
{
	QueryVariable *qv = new QueryVariable (varName, varValue);
	Append (qv);
}

const char *QueryVariable::FindName (const char *varName)
{
	const QueryVariable	*p = head;

	while (p)
	{
		if (!strcmp (varName, p->name))
			return	p->value;
		else
			p = p->next;
	}
	return	NULL;
}


int ParseToList (const char *szQueryString)
{
	register	i = 0;
	char		nameBuf [256];
	char		valueBuf [512];
	int			numVarsMade = 0;

	while (szQueryString[i])
	{
		int	curStart = i;

		while (szQueryString[i]  &&  szQueryString[i] != '='
				&&  szQueryString[i] != '&')
			++i;
		if (i - curStart > 255)	// excessively long variable name
			break;
		++i;
		if (i-1 > curStart  &&  szQueryString[i-1] == '=')
		{
			strncpy (nameBuf, szQueryString + curStart, i-1 - curStart);
			nameBuf [i-1 - curStart] = '\0';
			curStart = i;
			while (szQueryString[i]  &&  szQueryString[i] != '&')
				++i;
			if (i - curStart > 511)	// excessively long variable value
				break;
			for (register j = 0, k = 0; j < i - curStart; ++j, ++k)
				switch (szQueryString [j + curStart])
				{
					case '+':
						valueBuf[k] = ' ';
						break;
					case '*':
						valueBuf[k] = (char) 176;	// the ANSI degrees sign
						break;
					case '\'':
						valueBuf[k] = '\'';
						valueBuf[++k] = '\'';
						break;
					case '%':
					{
						char	hexDigits[3];

						hexDigits [0] = szQueryString [j + curStart + 1];
						if (isxdigit (hexDigits[0]))
						{
							hexDigits [1] = szQueryString [j + curStart + 2];
							if (!isxdigit (hexDigits[1]))
							{
								hexDigits [1] = '\0';
								++ j;
							}
							else
							{
								hexDigits [2] = '\0';
								j += 2;
							}
							valueBuf[k] = (char) strtol (hexDigits, NULL, 16);
							if (valueBuf[k] == '\'')
								valueBuf[++k] = '\'';
						}
						else
							valueBuf[k] = '%';
						break;
					}
					default:
						valueBuf[k] = szQueryString [j + curStart];
				}
			valueBuf [k] = '\0';
			QueryVariable::MakeAndAppend (nameBuf, valueBuf);
			++ numVarsMade;
			if (szQueryString[i] == '&')
				++i;
		}
	}
	return	numVarsMade;
}
